#ifndef _BASE_H_
#define _BASE_H_ 

#include <ewave/kernel/eiff.h>

class Base
{
 public:
  Base () {}
  virtual ~Base () {}
  virtual int write (EIFF *) {}
  virtual int read (EIFF *) {}
};

class UBase : public Base
{
 public:
  UBase ()
    {
      id = next_uid;
      next_uid++;
    }
  virtual ~UBase () {}
  void set_id (long i) { id = i; }
  long get_id () { return id; }
  virtual int write (EIFF *eiff)
    {
      eiff_write_long (eiff, get_id());
    }
  virtual int read (EIFF *eiff)
    {
      id = eiff_read_long (eiff);
      printf ("UID=%ld\n", id);
      if (id > next_uid) 
	next_uid = id + 1;
    }
 private:
  long id;
  static long next_uid;
};

#endif
