#!/usr/bin/guile \
-s
!#

; adjuster.scm
; This script is functionally equivalent to the adjuster.cxx
; program included in the Fltk test directory.

(use-modules (gfltk gfltk))

(define adjcb 
  (lambda (widget box)
    (fltk-widget::set-label box (fltk-valuator::format widget))
    (fltk-widget::redraw box)))
  
(define window 
  (fltk-window::new -1 -1 320 100 "Adjuster Demo"))

(define b1 
  (fltk-box::new 20 30 80 25 ""))
(fltk-widget::set-box b1 FL_DOWN_BOX)
(fltk-widget::set-color b1 FL_WHITE)

(define a1 
  (fltk-adjuster::new (+ 20 80) 30 (* 3 25) 25 ""))
(fltk-widget::set-callback a1 adjcb)
(fltk-widget::set-argument a1 b1)
(adjcb a1 b1)

(define b2 
  (fltk-box::new (+ 20 80 (* 4 25)) 30 80 25 ""))
(fltk-widget::set-box b2 FL_DOWN_BOX)
(fltk-widget::set-color b2 FL_WHITE)
(define a2 
  (fltk-adjuster::new (+ (fltk-widget::x b2) (fltk-widget::w b2)) 
		     10 25 (* 3 25) ""))
(fltk-widget::set-callback a2 adjcb)
(fltk-widget::set-argument a2 b2)
(adjcb a2 b2)

(fltk-group::set-resizable window window)
(fltk-group::end window)
(fltk-window::show window)
(fltk-fl::run)
