#! /usr/bin/guile \
-s
!#

; boxtype.scm
; This script is functionally equivalent to the boxtype.cxx
; program included in the Fltk test directory.

(use-modules (gfltk gfltk))

(define N 0)
(define W 150)
(define H 50)
(define ROWS 8)

(define bt 
  (lambda (name type)
     (define x (floor (modulo N 4)))
     (define y (floor (/ N 4)))
     (define box #f)
    (set! N (+ N 1))
    (set! x (+ 10 (* x W)))
    (set! y (+ 10 (* y H)))
    (set! box (fltk-box::new (round x) (round y) (- W 20) (- H 20) name))
    (fltk-widget::set-box box type)
    (fltk-widget::set-label-size box 11)))

(define window (fltk-window::new -1 -1 (* 4 W) (* ROWS H) "Box Type Demo"))
(fltk-widget::set-box window FL_FLAT_BOX)
(fltk-widget::set-color window 12) ; light blue
(bt "FL_NO_BOX" FL_NO_BOX)
(bt "FL_FLAT_BOX" FL_FLAT_BOX)
(set! N (+ N 2))
(bt "FL_UP_BOX" FL_UP_BOX)
(bt "FL_DOWN_BOX" FL_DOWN_BOX)
(bt "FL_UP_FRAME" FL_UP_FRAME)
(bt "FL_DOWN_FRAME" FL_DOWN_FRAME)
(bt "FL_THIN_UP_BOX" FL_THIN_UP_BOX)
(bt "FL_THIN_DOWN_BOX" FL_THIN_DOWN_BOX)
(bt "FL_THIN_UP_FRAME" FL_THIN_UP_FRAME)
(bt "FL_THIN_DOWN_FRAME" FL_THIN_DOWN_FRAME)
(bt "FL_ENGRAVED_BOX" FL_ENGRAVED_BOX)
(bt "FL_EMBOSSED_BOX" FL_EMBOSSED_BOX)
(bt "FL_ENGRAVED_FRAME" FL_ENGRAVED_FRAME)
(bt "FL_EMBOSSED_FRAME" FL_EMBOSSED_FRAME)
(bt "FL_BORDER_BOX" FL_BORDER_BOX)
(bt "FL_SHADOW_BOX" FL_SHADOW_BOX)
(bt "FL_BORDER_FRAME" FL_BORDER_FRAME)
(bt "FL_SHADOW_FRAME" FL_SHADOW_FRAME)
(bt "FL_ROUNDED_BOX" FL_ROUNDED_BOX)
(bt "FL_RSHADOW_BOX" FL_RSHADOW_BOX)
(bt "FL_ROUNDED_FRAME" FL_ROUNDED_FRAME)
(bt "FL_RFLAT_BOX" FL_RFLAT_BOX)
(bt "FL_OVAL_BOX" FL_OVAL_BOX)
(bt "FL_OSHADOW_BOX" FL_OSHADOW_BOX)
(bt "FL_OVAL_FRAME" FL_OVAL_FRAME)
(bt "FL_OFLAT_BOX" FL_OFLAT_BOX)
(bt "FL_ROUND_UP_BOX" FL_ROUND_UP_BOX)
(bt "FL_ROUND_DOWN_BOX" FL_ROUND_DOWN_BOX)
(bt "FL_DIAMOND_UP_BOX" FL_DIAMOND_UP_BOX)
(bt "FL_DIAMOND_DOWN_BOX" FL_DIAMOND_DOWN_BOX)
(fltk-group::set-resizable window window)
(fltk-group::end window)
(fltk-window::show window)
(fltk-fl::run)

