#ifndef GFL_H_
#define GFL_H_

#include <stdio.h>
#include <stdarg.h>
#include <libguile.h>
#include <guile/gh.h>

#ifdef __hppa
# undef va_start
# define va_start(a,b) ((a)=(va_list)&(b))
#endif

#define GFL_PROCEDURE_0_0(fn, sfn, doc) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {0, 0}, {0, 0}}; \
    SCM fn () 

#define GFL_PROCEDURE_0_1(fn, sfn, doc, r1, rt1) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	   {0, 0}, {(long) &rt1 ## _class_tag, #r1}, {0, 0}}; \
    SCM fn () 

#define GFL_PROCEDURE_1_0(fn, sfn, doc, a1, at1) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {0, 0}, {0, 0}}; \
    SCM fn (SCM a1) 

#define GFL_PROCEDURE_2_0(fn, sfn, doc, a1, a2, at1, at2) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {(long) &at2 ## _class_tag, #a2}, {0, 0}, {0, 0}}; \
    SCM fn (SCM a1, SCM a2) 

#define GFL_PROCEDURE_3_0(fn, sfn, doc, a1, a2, a3, at1, at2, at3) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {(long) &at2 ## _class_tag, #a2}, {(long) &at3 ## _class_tag, #a3}, {0, 0}, {0, 0}}; \
    SCM fn (SCM a1, SCM a2, SCM a3, SCM a4) 

#define GFL_PROCEDURE_4_0(fn, sfn, doc, a1, a2, a3, a4, at1, at2, at3, at4) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {(long) &at2 ## _class_tag, #a2}, {(long) &at3 ## _class_tag, #a3}, {(long) &at4 ## _class_tag, #a4}, {0, 0}, {0, 0}}; \
    SCM fn (SCM a1, SCM a2, SCM a3, SCM a4) 

#define GFL_PROCEDURE_5_0(fn, sfn, doc, a1, a2, a3, a4, a5, at1, at2, at3, at4, at5) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1  ## _class_tag, #a1}, {(long) &at2 ## _class_tag, #a2}, {(long) &at3 ## _class_tag, #a3}, {(long) &at4 ## _class_tag, #a4}, {(long) &at5 ## _class_tag, #a5}, {0, 0}, {0, 0}}; \
    SCM fn (SCM a1, SCM a2, SCM a3, SCM a4, SCM a5) 

#define GFL_PROCEDURE_1_1(fn, sfn, doc, a1, at1, r1, rt1) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {0, 0}, \
	    {(long) &rt1 ## _class_tag, #r1}, {0, 0}}; \
    SCM fn (SCM a1) 

#define GFL_PROCEDURE_2_1(fn, sfn, doc, a1, a2, at1, at2, r1, rt1) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {(long) &at2 ## _class_tag, #a2}, {0, 0}, \
	    {(long) &rt1 ## _class_tag, #r1}, {0, 0}}; \
    SCM fn (SCM a1, SCM a2) 

#define GFL_PROCEDURE_3_1(fn, sfn, doc, a1, a2, a3, at1, at2, at3, r1, rt1) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {(long) &at2 ## _class_tag, #a2}, {(long) &at3 ## _class_tag, #a3}, {0, 0}, \
	    {(long) &rt1 ## _class_tag, #r1}, {0, 0}}; \
    SCM fn (SCM a1, SCM a2, SCM a3) 

#define GFL_PROCEDURE_5_1(fn, sfn, doc, a1, a2, a3, a4, a5, at1, at2, at3, at4, at5, r1, rt1) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {(long) &at2 ## _class_tag, #a2}, {(long) &at3 ## _class_tag, #a3}, {(long) &at4 ## _class_tag, #a4}, {(long) &at5 ## _class_tag, #a5}, {0, 0}, \
	    {(long) &rt1 ## _class_tag, #r1}, {0, 0}}; \
    SCM fn (SCM a1, SCM a2, SCM a3, SCM a4, SCM a5) 

#define GFL_PROCEDURE_6_1(fn, sfn, doc, a1, a2, a3, a4, a5, a6, at1, at2, at3, at4, at5, at6, r1, rt1) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {(long) &at2 ## _class_tag, #a2}, {(long) &at3 ## _class_tag, #a3}, {(long) &at4 ## _class_tag, #a4}, {(long) &at5 ## _class_tag, #a5}, {(long) &at6 ## _class_tag, #a6}, {0, 0}, \
	    {(long) &rt1 ## _class_tag, #r1}, {0, 0}}; \
    SCM fn (SCM a1, SCM a2, SCM a3, SCM a4, SCM a5, SCM a6) 

#define GFL_PROCEDURE_1_2(fn, sfn, doc, a1, at1, r1, r2, rt1, rt2) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {0, 0}, \
	    {(long) &rt1 ## _class_tag, #r1}, {(long) &rt2 ## _class_tag, #r2}, {0, 0}}; \
    SCM fn (SCM a1) 

#define GFL_PROCEDURE_1_4(fn, sfn, doc, a1, at1, r1, r2, r3, r4, rt1, rt2, rt3, rt4) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {0, 0}, \
	    {(long) &rt1 ## _class_tag, #r1}, {(long) &rt2 ## _class_tag, #r2}, \
	    {(long) &rt2 ## _class_tag, #r2}, {(long) &rt4 ## _class_tag, #r4}, {0, 0}}; \
    SCM fn (SCM a1) 

#define GFL_PROCEDURE_3_3(fn, sfn, doc, a1, a2, a3, at1, at2, at3, r1, r2, r3, rt1, rt2, rt3) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {(long) &at2 ## _class_tag, #a2}, {(long) &at3 ## _class_tag, #a3}, {0, 0}, \
	    {(long) &rt1 ## _class_tag, #r1}, {(long) &rt2 ## _class_tag, #r2}, {(long) &rt3 ## _class_tag, #r3}, {0, 0}}; \
    SCM fn (SCM a1, SCM a2, SCM a3) 

#define GFL_PROCEDURE_4_4(fn, sfn, doc, a1, a2, a3, a4, at1, at2, at3, at4, r1, r2, r3, r4, rt1, rt2, rt3, rt4) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {(long) &at2 ## _class_tag, #a2}, {(long) &at3 ## _class_tag, #a3}, {(long) &at4 ## _class_tag, #a4}, {0, 0}, \
	    {(long) &rt1 ## _class_tag, #r1}, {(long) &rt2 ## _class_tag, #r2}, {(long) &rt3 ## _class_tag, #r3}, {(long) &rt4 ## _class_tag, #r4}, {0, 0}}; \
    SCM fn (SCM a1, SCM a2, SCM a3, SCM a4) 

#define GFL_PROCEDURE_4_1(fn, sfn, doc, a1, a2, a3, a4, at1, at2, at3, at4, r1, rt1) \
    Gfl_Info fn ## _i[] = { {0, sfn}, {0, doc}, \
	    {(long) &at1 ## _class_tag, #a1}, {(long) &at2 ## _class_tag, #a2}, {(long) &at3 ## _class_tag, #a3}, {(long) &at4 ## _class_tag, #a4}, {0, 0}, \
	    {(long) &rt1 ## _class_tag, #r1}, {0, 0}}; \
    SCM fn (SCM a1, SCM a2, SCM a3, SCM a4) 


#define GFL_ASSERT_1(fn, a1) gfl_assert(fn ## _i, a1)
#define GFL_ASSERT_2(fn, a1, a2) gfl_assert(fn ## _i, a1, a2)
#define GFL_ASSERT_3(fn, a1, a2, a3) gfl_assert(fn ## _i, a1, a2, a3)
#define GFL_ASSERT_4(fn, a1, a2, a3, a4) gfl_assert(fn ## _i, a1, a2, a3, a4)
#define GFL_ASSERT_5(fn, a1, a2, a3, a4, a5) gfl_assert(fn ## _i, a1, a2, a3, a4, a5)
#define GFL_ASSERT_6(fn, a1, a2, a3, a4, a5, a6) gfl_assert(fn ## _i, a1, a2, a3, a4, a5, a6)
#define GFL_ASSERT_7(fn, a1, a2, a3, a4, a5, a6, a7) gfl_assert(fn ## _i, a1, a2, a3, a4, a5, a6, a7)
#define GFL_ASSERT_8(fn, a1, a2, a3, a4, a5, a6, a7, a8) gfl_assert(fn ## _i, a1, a2, a3, a4, a5, a6, a7, a8)
#define GFL_ASSERT_9(fn, a1, a2, a3, a4, a5, a6, a7, a8, a9) gfl_assert(fn ## _i, a1, a2, a3, a4, a5, a6, a7, a8, a9)

#define GFL_NEW_PROCEDURE(fn) gfl_new_procedure(fn ## _i, fn)

#define GFL_NEW_SMOB(o, smob, data) \
    SCM_NEWCELL (smob); \
    SCM_SETCDR (smob, data); \
    SCM_SETCAR (smob, o ## _class_tag.tag);

#define GFL_NEW_WIDGET_SMOB(o, smob, data) \
    SCM_NEWCELL (smob); \
    SCM_SETCDR (smob, data); \
    SCM_SETCAR (smob, o ## _class_tag.tag); \
    gfl_register (smob)

#define GFL_NEW_TYPE(aa) aa ## _class_init()

#define GFL_EXTERN_TYPE(nn) \
    extern Gfl_Class nn ## _class_tag

#define GFL_SUBCLASS_TYPE(nn, dd, oo, pp, wmark, wfree, wprint) \
    Gfl_Class oo ## _class_tag; \
    extern void pp ## _class_subclass(long); \
    extern Gfl_Class pp ## _class_tag; \
    static scm_smobfuns smobfuns = { wmark, wfree, wprint, 0 }; \
    void oo ## _class_init() { \
      oo ## _class_tag.name = nn; \
      oo ## _class_tag.docstr = dd; \
      oo ## _class_tag.tag = scm_newsmob(&smobfuns); \
      oo ## _class_tag.parent = & pp ## _class_tag; \
      oo ## _class_tag.subclasses = (long *)malloc(sizeof(long)); \
      oo ## _class_tag.subclasses[0] = oo ## _class_tag.tag; \
      oo ## _class_tag.subclasses_cnt = 1; \
      gfl_register_class (& oo ## _class_tag); \
      pp ## _class_subclass(oo ## _class_tag.tag); \
    } \
    void oo ## _class_subclass(long gg) { \
      long mj = oo ## _class_tag.subclasses_cnt + 1; \
      oo ## _class_tag.subclasses_cnt = mj; \
      oo ## _class_tag.subclasses = (long *)realloc (oo ## _class_tag.subclasses, sizeof(long) * mj); \
      oo ## _class_tag.subclasses[mj-1] = gg; \
      pp ## _class_subclass(gg); \
    }

#define GFL_CLASS_TYPE(nn, dd, oo, wmark, wfree, wprint) \
    Gfl_Class oo ## _class_tag; \
    static scm_smobfuns smobfuns = { wmark, wfree, wprint, 0 }; \
    void oo ## _class_init() { \
      oo ## _class_tag.name = nn; \
      oo ## _class_tag.docstr = dd; \
      oo ## _class_tag.tag = scm_newsmob(&smobfuns); \
      oo ## _class_tag.parent = 0; \
      oo ## _class_tag.subclasses = (long *)malloc(sizeof(long)); \
      oo ## _class_tag.subclasses[0] = oo ## _class_tag.tag; \
      oo ## _class_tag.subclasses_cnt = 1; \
    } \
    void oo ## _class_subclass(long gg) { \
      long mj = oo ## _class_tag.subclasses_cnt + 1; \
      oo ## _class_tag.subclasses_cnt = mj; \
      oo ## _class_tag.subclasses = (long *)realloc (oo ## _class_tag.subclasses, sizeof(long) * mj); \
      oo ## _class_tag.subclasses[mj-1] = gg; \
    }

#define GFL_TYPE(nn, dd, oo) \
    Gfl_Class oo ## _class_tag; \
    void oo ## _class_init() { \
      oo ## _class_tag.name = nn; \
      oo ## _class_tag.docstr = dd; \
      oo ## _class_tag.tag = 0; \
      oo ## _class_tag.parent = 0; \
      oo ## _class_tag.subclasses = 0; \
      oo ## _class_tag.subclasses_cnt = 0; \
    } 

#ifdef __cplusplus
extern "C" {
#endif

  typedef SCM (*Gfl_Proc)();
  typedef SCM (*Gfl_Proc0)(void);
  typedef SCM (*Gfl_Proc1)(SCM);
  typedef SCM (*Gfl_Proc2)(SCM, SCM);
  typedef SCM (*Gfl_Proc3)(SCM, SCM, SCM);
  typedef SCM (*Gfl_Proc4)(SCM, SCM, SCM, SCM);
  typedef SCM (*Gfl_Proc5)(SCM, SCM, SCM, SCM, SCM);
  typedef SCM (*Gfl_Proc6)(SCM, SCM, SCM, SCM, SCM, SCM);
  typedef SCM (*Gfl_Proc7)(SCM, SCM, SCM, SCM, SCM, SCM, SCM);
  typedef SCM (*Gfl_Proc8)(SCM, SCM, SCM, SCM, SCM, SCM, SCM, SCM);
  typedef SCM (*Gfl_Proc9)(SCM, SCM, SCM, SCM, SCM, SCM, SCM, SCM, SCM);

  typedef struct Gfl_Class
    {
      struct Gfl_Class *parent;
      char *name;
      char *docstr;
      long tag;
      long *subclasses;
      long subclasses_cnt;
    } Gfl_Class;
  
  typedef struct Gfl_Info
    {
      int id;
      char *label;
    } Gfl_Info;
  
  int gfl_init();
  int gfl_add_ (Gfl_Info *info, Gfl_Proc proc,  long arg);
  int gfl_add0 (Gfl_Info *info, Gfl_Proc0 proc, long arg);
  int gfl_add1 (Gfl_Info *info, Gfl_Proc1 proc, long arg);
  int gfl_add2 (Gfl_Info *info, Gfl_Proc2 proc, long arg);
  int gfl_add3 (Gfl_Info *info, Gfl_Proc3 proc, long arg);
  int gfl_add4 (Gfl_Info *info, Gfl_Proc4 proc, long arg);
  int gfl_add5 (Gfl_Info *info, Gfl_Proc5 proc, long arg);
  int gfl_add6 (Gfl_Info *info, Gfl_Proc6 proc, long arg);
  int gfl_add7 (Gfl_Info *info, Gfl_Proc7 proc, long arg);
  int gfl_add8 (Gfl_Info *info, Gfl_Proc8 proc, long arg);
  int gfl_add9 (Gfl_Info *info, Gfl_Proc9 proc, long arg);
  
  SCM gfl_new_procedure0 (Gfl_Info *args, Gfl_Proc0);
  SCM gfl_new_procedure1 (Gfl_Info *args, Gfl_Proc1);
  SCM gfl_new_procedure2 (Gfl_Info *args, Gfl_Proc2);
  SCM gfl_new_procedure3 (Gfl_Info *args, Gfl_Proc3);
  SCM gfl_new_procedure4 (Gfl_Info *args, Gfl_Proc4);
  SCM gfl_new_procedure5 (Gfl_Info *args, Gfl_Proc5);
  SCM gfl_new_procedure6 (Gfl_Info *args, Gfl_Proc6);
  SCM gfl_new_procedure7 (Gfl_Info *args, Gfl_Proc7);
  SCM gfl_new_procedure8 (Gfl_Info *args, Gfl_Proc8);
  SCM gfl_new_procedure9 (Gfl_Info *args, Gfl_Proc9);
  
  SCM gfl_exe (char *name, ...);
  SCM gfl_doc (SCM a);
  Gfl_Info *gfl_find_info (char *name);
  void gfl_assert (Gfl_Info *args, ...);
  void gfl_register_class(Gfl_Class*);
  
  GFL_EXTERN_TYPE (int);
  GFL_EXTERN_TYPE (int_array);
  GFL_EXTERN_TYPE (char);
  GFL_EXTERN_TYPE (bool);
  GFL_EXTERN_TYPE (double);
  GFL_EXTERN_TYPE (float);
  GFL_EXTERN_TYPE (long);
  GFL_EXTERN_TYPE (str);
  GFL_EXTERN_TYPE (symbol);
  GFL_EXTERN_TYPE (any);
  GFL_EXTERN_TYPE (callback);
  GFL_EXTERN_TYPE (fltk_boxtype);
  GFL_EXTERN_TYPE (fltk_color);
  GFL_EXTERN_TYPE (fltk_font);
  GFL_EXTERN_TYPE (fltk_when);
  GFL_EXTERN_TYPE (fltk_menu_item);
  GFL_EXTERN_TYPE (fltk_menu_buttontype);
  GFL_EXTERN_TYPE (fltk_charttype);
  
#ifdef __cplusplus
}

// gfl_add is overloaded for c++

inline int gfl_add (Gfl_Info *info, Gfl_Proc0 proc, long arg)
  { return gfl_add0 (info, proc, arg); }
inline int gfl_add (Gfl_Info *info, Gfl_Proc1 proc, long arg)
  { return gfl_add1 (info, proc, arg); }
inline int gfl_add (Gfl_Info *info, Gfl_Proc2 proc, long arg)
  { return gfl_add2 (info, proc, arg); }
inline int gfl_add (Gfl_Info *info, Gfl_Proc3 proc, long arg)
  { return gfl_add3 (info, proc, arg); }
inline int gfl_add (Gfl_Info *info, Gfl_Proc4 proc, long arg)
  { return gfl_add4 (info, proc, arg); }
inline int gfl_add (Gfl_Info *info, Gfl_Proc5 proc, long arg)
  { return gfl_add5 (info, proc, arg); }
inline int gfl_add (Gfl_Info *info, Gfl_Proc6 proc, long arg)
  { return gfl_add6 (info, proc, arg); }
inline int gfl_add (Gfl_Info *info, Gfl_Proc7 proc, long arg)
  { return gfl_add7 (info, proc, arg); }
inline int gfl_add (Gfl_Info *info, Gfl_Proc8 proc, long arg)
  { return gfl_add8 (info, proc, arg); }
inline int gfl_add (Gfl_Info *info, Gfl_Proc9 proc, long arg)
  { return gfl_add9 (info, proc, arg); }

inline SCM gfl_new_procedure (Gfl_Info *args, Gfl_Proc0 fn)
  { return gfl_new_procedure0 (args, fn); }
inline SCM gfl_new_procedure (Gfl_Info *args, Gfl_Proc1 fn)
  { return gfl_new_procedure1 (args, fn); }
inline SCM gfl_new_procedure (Gfl_Info *args, Gfl_Proc2 fn)
  { return gfl_new_procedure2 (args, fn); }
inline SCM gfl_new_procedure (Gfl_Info *args, Gfl_Proc3 fn)
  { return gfl_new_procedure3 (args, fn); }
inline SCM gfl_new_procedure (Gfl_Info *args, Gfl_Proc4 fn)
  { return gfl_new_procedure4 (args, fn); }
inline SCM gfl_new_procedure (Gfl_Info *args, Gfl_Proc5 fn)
  { return gfl_new_procedure5 (args, fn); }
inline SCM gfl_new_procedure (Gfl_Info *args, Gfl_Proc6 fn)
  { return gfl_new_procedure6 (args, fn); }
inline SCM gfl_new_procedure (Gfl_Info *args, Gfl_Proc7 fn)
  { return gfl_new_procedure7 (args, fn); }
inline SCM gfl_new_procedure (Gfl_Info *args, Gfl_Proc8 fn)
  { return gfl_new_procedure8 (args, fn); }
inline SCM gfl_new_procedure (Gfl_Info *args, Gfl_Proc9 fn)
  { return gfl_new_procedure9 (args, fn); }

#endif

#endif
