#ifndef FLTK_GUILE
#define FLTK_GUILE 1
#include <libguile.h>
#include <guile/gh.h>
#include <FL/Fl_Widget.H>
#include <FL/Fl.H>
#include <gFL/gfl.h>

#define GUILE_FLTK_MAJOR 0
#define GUILE_FLTK_MINOR 4
#define GUILE_FLTK_PATCH 0

typedef SCM (*guilefp)(...);

typedef struct GFL_Widget 
{
  Fl_Widget *widget;
  SCM smob;
  SCM callback;
  SCM argument;
} GFL_Widget;

extern "C" 
{
  extern void scm_init_gfltk_gfltk_module();
  extern void scm_init_fltk();
}

extern void guile_fltk_callback(Fl_Widget *, void *);
extern void guile_fltk_callback2(Fl_Widget *, void *);

extern void gfl_register(SCM);
extern SCM  gfl_lookup(Fl_Widget *);
extern SCM  gfl_lookup2(Fl_Widget *, long);
extern SCM  gfl_get_callback(Fl_Widget *);
extern void gfl_set_callback(Fl_Widget *, SCM);
extern void gfl_remove(SCM);
extern void gfl_class_register(long, long);
extern int  gfl_type_p(SCM, long);
extern void gfl_export_object (char *, Fl_Widget *, long);

extern void fltk_fl_init ();
extern void fltk_widget_init ();
extern void fltk_menu_init ();
extern void fltk_menu_bar_init ();
extern void fltk_browser_base_init ();
extern void fltk_browser_init ();
extern void fltk_hold_browser_init ();
extern void fltk_multi_browser_init ();
extern void fltk_select_browser_init ();
extern void fltk_group_init ();
extern void fltk_tile_init ();
extern void fltk_tabs_init ();
extern void fltk_window_init ();
extern void fltk_button_init ();
extern void fltk_box_init ();
extern void fltk_check_button_init ();
extern void fltk_light_button_init ();
extern void fltk_repeat_button_init ();
extern void fltk_return_button_init ();
extern void fltk_round_button_init ();
extern void fltk_valuator_init ();
extern void fltk_adjuster_init ();
extern void fltk_counter_init ();
extern void fltk_timer_init ();
extern void fltk_dial_init ();
extern void fltk_roller_init ();
extern void fltk_slider_init ();
extern void fltk_value_input_init ();
extern void fltk_value_output_init ();
extern void fltk_clock_init ();
extern void fltk_round_clock_init ();
extern void fltk_input_base_init ();
extern void fltk_input_init ();
extern void fltk_float_input_init ();
extern void fltk_int_input_init ();
extern void fltk_secret_input_init ();
extern void fltk_multiline_input_init ();
extern void fltk_chart_init ();
extern void fltk_choice_init ();
extern void fltk_color_chooser_init ();
extern void fltk_menu_button_init ();
extern void fltk_output_init ();
extern void fltk_value_slider_init ();

#endif
